﻿package;

import com.eclecticdesignstudio.motion.Actuate;
import nme.display.Bitmap;
import nme.display.Sprite;
import nme.display.StageAlign;
import nme.display.StageScaleMode;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.Assets;
import nme.Lib;

class Demo extends Sprite {
	private var logo: Sprite;

	public function new() {
		super();
		addEventListener(Event.ADDED_TO_STAGE, init);
	}

	private function init(event: Event): Void {
		//スプライトを作る
		logo = new Sprite();

		//画像データを BitmapData で読みだして
		var bitmapData = Assets.getBitmapData("assets/nme.png");
		//Bitmap クラスに割り当てて
		var bitmap = new Bitmap(bitmapData);
		//それをスプライトの子階層に配置する
		logo.addChild(bitmap);
		//Bitmap の位置は左上に半分ずらして、
		//スプライトの (0, 0) の地点が Bitmap の中央に来るようにする
		bitmap.x = -bitmapData.width * 0.5;
		bitmap.y = -bitmapData.height * 0.5;

		//画像データを抱えたスプライトを画面に追加
		addChild(logo);

		//画面の中央に配置
		logo.x = stage.stageWidth * 0.5;
		logo.y = stage.stageHeight * 0.5;

		logo.alpha = 1.0;
		logo.scaleX = 1.0;
		logo.scaleY = 1.0;

		//スプライトがクリックされた時の挙動を追加
		logo.addEventListener(MouseEvent.CLICK, function(event: Event): Void {
			//スプライト logo を 0.5秒間 で 縦横2倍に拡大しながらフェードアウト
			Actuate.tween(logo, 0.5, {scaleX: 2.0, scaleY: 2.0, alpha: 0.0}).onComplete(function(): Void{
				//アニメーションが終わったら元に戻す
				logo.alpha = 1.0;
				logo.scaleX = 1.0;
				logo.scaleY = 1.0;
				logo.visible = true;
			});
		});
	}

	public static function main () {
		Lib.current.stage.align = StageAlign.TOP_LEFT;
		Lib.current.stage.scaleMode = StageScaleMode.NO_SCALE;
		Lib.current.addChild(new Demo());
	}
}
